org.apache.tinkerpop.gremlin.process.computer.traversal

## Class TraversalVertexProgram

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.computer.traversal.TraversalVertexProgram

- All Implemented Interfaces:
    Cloneable, VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>

      public final class TraversalVertexProgram
      extends Object
      implements VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>

  `TraversalVertexProgram` enables the evaluation of a `Traversal` on a `GraphComputer`. At the start of the computation, each `Vertex` (or `Edge`) is assigned a single `Traverser`. For each traverser that is local to the vertex, the vertex looks up its current location in the traversal and processes that step. If the outputted traverser of the step references a local structure on the vertex (e.g. the vertex, an incident edge, its properties, or an arbitrary object), then the vertex continues to compute the next traverser. If the traverser references another location in the graph, then the traverser is sent to that location in the graph via a message. The messages of TraversalVertexProgram are traversers. This continues until all traversers in the computation have halted.
  Author:
    Marko A. Rodriguez (http://markorodriguez.com)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `TraversalVertexProgram.Builder`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VertexProgram.Features`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ACTIVE_TRAVERSERS`
    `static String` | `HALTED_TRAVERSERS`
    `protected static String` | `MUTATED_MEMORY_KEYS`
    `static String` | `TRAVERSAL`

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VERTEX_PROGRAM`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static TraversalVertexProgram.Builder` | `build()`
    `TraversalVertexProgram` | `clone()` When multiple workers on a single machine need VertexProgram instances, it is possible to use clone.
    `void` | `execute(Vertex vertex, Messenger<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>> messenger, Memory memory)` This method denotes the main body of the computation and is executed on each vertex in the graph.
    `VertexProgram.Features` | `getFeatures()`
    `Set<MapReduce>` | `getMapReducers()` The set of `MapReduce` jobs that are associated with the `VertexProgram`.
    `Set<MemoryComputeKey>` | `getMemoryComputeKeys()` The `Memory` keys that will be used during the computation.
    `Optional<MessageCombiner<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>>` | `getMessageCombiner()` Combine the messages in route to a particular vertex.
    `Set<MessageScope>` | `getMessageScopes(Memory memory)` This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program.
    `GraphComputer.Persist` | `getPreferredPersist()`
    `GraphComputer.ResultGraph` | `getPreferredResultGraph()`
    `org.apache.tinkerpop.gremlin.process.traversal.util.PureTraversal<?,?>` | `getTraversal()` Get the `PureTraversal` associated with the current instance of the `TraversalVertexProgram`.
    `Set<VertexComputeKey>` | `getVertexComputeKeys()` The `Element` properties that will be mutated during the computation.
    `static <R> org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<R>` | `loadHaltedTraversers(org.apache.commons.configuration2.Configuration configuration)`
    `void` | `loadState(Graph graph, org.apache.commons.configuration2.Configuration configuration)` When it is necessary to load the state of the VertexProgram, this method is called.
    `void` | `setup(Memory memory)` The method is called at the beginning of the computation.
    `static <R> void` | `storeHaltedTraversers(org.apache.commons.configuration2.Configuration configuration, org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<R> haltedTraversers)`
    `void` | `storeState(org.apache.commons.configuration2.Configuration configuration)` When it is necessary to store the state of the VertexProgram, this method is called.
    `boolean` | `terminate(Memory memory)` The method is called at the end of each iteration to determine if the computation is complete.
    `String` | `toString()`
    `void` | `workerIterationEnd(Memory memory)` This method is called at the end of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism.
    `void` | `workerIterationStart(Memory memory)` This method is called at the start of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `createVertexProgram, getTraverserRequirements`

- - ### Field Detail

    - #### TRAVERSAL

          public static final String TRAVERSAL

      See Also:
        Constant Field Values

    - #### HALTED_TRAVERSERS

          public static final String HALTED_TRAVERSERS

      See Also:
        Constant Field Values

    - #### ACTIVE_TRAVERSERS

          public static final String ACTIVE_TRAVERSERS

      See Also:
        Constant Field Values

    - #### MUTATED_MEMORY_KEYS

          protected static final String MUTATED_MEMORY_KEYS

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getTraversal

          public org.apache.tinkerpop.gremlin.process.traversal.util.PureTraversal<?,?> getTraversal()

      Get the `PureTraversal` associated with the current instance of the `TraversalVertexProgram`.
      Returns:
        the pure traversal of the instantiated program

    - #### loadHaltedTraversers

          public static <R> org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<R> loadHaltedTraversers(org.apache.commons.configuration2.Configuration configuration)

    - #### storeHaltedTraversers

          public static <R> void storeHaltedTraversers(org.apache.commons.configuration2.Configuration configuration,
                                                       org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<R> haltedTraversers)

    - #### loadState

          public void loadState(Graph graph,
                                org.apache.commons.configuration2.Configuration configuration)

      Description copied from interface: `VertexProgram`
      When it is necessary to load the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is loaded is simply the instance state, not any processed data.
      Specified by:
        `loadState` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Parameters:
        `graph` - the graph that the VertexProgram will run against
        `configuration` - the configuration to load the state of the VertexProgram from.

    - #### storeState

          public void storeState(org.apache.commons.configuration2.Configuration configuration)

      Description copied from interface: `VertexProgram`
      When it is necessary to store the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is stored is simply the instance/configuration state, not any processed data. The default implementation provided simply stores the VertexProgram class name for reflective reconstruction. It is typically a good idea to VertexProgram.super.storeState().
      Specified by:
        `storeState` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Parameters:
        `configuration` - the configuration to store the state of the VertexProgram in.

    - #### setup

          public void setup(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the beginning of the computation. The method is global to the `GraphComputer` and as such, is not called for each vertex. During this stage, the `Memory` should be initialized to to its "start state."
      Specified by:
        `setup` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Parameters:
        `memory` - The global memory of the GraphComputer

    - #### getMessageScopes

          public Set<MessageScope> getMessageScopes(Memory memory)

      Description copied from interface: `VertexProgram`
      This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program. The returned messages scopes are the scopes that will be used to send messages during the stated iteration. It is not a requirement that all stated messages scopes be used, just that it is possible that they be used during the iteration.
      Specified by:
        `getMessageScopes` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Parameters:
        `memory` - an immutable form of the `Memory`
      Returns:
        all possible message scopes during said vertex program iteration

    - #### execute

          public void execute(Vertex vertex,
                              Messenger<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>> messenger,
                              Memory memory)

      Description copied from interface: `VertexProgram`
      This method denotes the main body of the computation and is executed on each vertex in the graph. This method is logically executed in parallel on all vertices in the graph. When the `Memory` is read, it is according to the aggregated state yielded in the previous iteration. When the `Memory` is written, the data will be aggregated at the end of the iteration for reading in the next iteration.
      Specified by:
        `execute` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Parameters:
        `vertex` - the `Vertex` to execute the `VertexProgram` on
        `messenger` - the messenger that moves data between vertices
        `memory` - the shared state between all vertices in the computation

    - #### terminate

          public boolean terminate(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the end of each iteration to determine if the computation is complete. The method is global to the `GraphComputer` and as such, is not called for each `Vertex`. The `Memory` maintains the aggregated data from the last execute() iteration.
      Specified by:
        `terminate` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Parameters:
        `memory` - The global memory of the `GraphComputer`
      Returns:
        whether or not to halt the computation

    - #### workerIterationStart

          public void workerIterationStart(Memory memory)

      Description copied from interface: `VertexProgram`
      This method is called at the start of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism. The vertex set is split into subsets and a worker is assigned to call the `VertexProgram.execute(org.apache.tinkerpop.gremlin.structure.Vertex, org.apache.tinkerpop.gremlin.process.computer.Messenger<M>, org.apache.tinkerpop.gremlin.process.computer.Memory)` method. The default implementation is a no-op.
      Specified by:
        `workerIterationStart` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Parameters:
        `memory` - The memory at the start of the iteration.

    - #### workerIterationEnd

          public void workerIterationEnd(Memory memory)

      Description copied from interface: `VertexProgram`
      This method is called at the end of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism. The vertex set is split into subsets and a worker is assigned to call the `VertexProgram.execute(org.apache.tinkerpop.gremlin.structure.Vertex, org.apache.tinkerpop.gremlin.process.computer.Messenger<M>, org.apache.tinkerpop.gremlin.process.computer.Memory)` method. The default implementation is a no-op.
      Specified by:
        `workerIterationEnd` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Parameters:
        `memory` - The memory at the end of the iteration.

    - #### getVertexComputeKeys

          public Set<VertexComputeKey> getVertexComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Element` properties that will be mutated during the computation. All properties in the graph are readable, but only the keys specified here are writable. The default is an empty set.
      Specified by:
        `getVertexComputeKeys` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Returns:
        the set of element keys that will be mutated during the vertex program's execution

    - #### getMemoryComputeKeys

          public Set<MemoryComputeKey> getMemoryComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Memory` keys that will be used during the computation. These are the only keys that can be read or written throughout the life of the `GraphComputer`. The default is an empty set.
      Specified by:
        `getMemoryComputeKeys` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Returns:
        the set of memory keys that will be read/written

    - #### getMapReducers

          public Set<MapReduce> getMapReducers()

      Description copied from interface: `VertexProgram`
      The set of `MapReduce` jobs that are associated with the `VertexProgram`. This is not necessarily the exhaustive list over the life of the `GraphComputer`. If MapReduce jobs are declared by GraphComputer.mapReduce(), they are not contained in this set. The default is an empty set.
      Specified by:
        `getMapReducers` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Returns:
        the set of `MapReduce` jobs associated with this `VertexProgram`

    - #### getMessageCombiner

          public Optional<MessageCombiner<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>> getMessageCombiner()

      Description copied from interface: `VertexProgram`
      Combine the messages in route to a particular vertex. Useful to reduce the amount of data transmitted over the wire. For example, instead of sending two objects that will ultimately be merged at the vertex destination, merge/combine into one and send that object. If no message combiner is provider, then no messages will be combined. Furthermore, it is not guaranteed the all messages in route to the vertex will be combined and thus, combiner-state should not be used. The result of the vertex program algorithm should be the same regardless of whether message combining is executed or not.
      Specified by:
        `getMessageCombiner` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Returns:
        A optional denoting whether or not their is a message combine associated with the vertex program.

    - #### clone

          public TraversalVertexProgram clone()

      Description copied from interface: `VertexProgram`
      When multiple workers on a single machine need VertexProgram instances, it is possible to use clone. This will provide a speedier way of generating instances, over the `VertexProgram.storeState(org.apache.commons.configuration2.Configuration)` and `VertexProgram.loadState(org.apache.tinkerpop.gremlin.structure.Graph, org.apache.commons.configuration2.Configuration)` model. The default implementation simply returns the object as it assumes that the VertexProgram instance is a stateless singleton.
      Specified by:
        `clone` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`
      Overrides:
        `clone` in class `Object`
      Returns:
        A clone of the VertexProgram object

    - #### getPreferredResultGraph

          public GraphComputer.ResultGraph getPreferredResultGraph()

      Specified by:
        `getPreferredResultGraph` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`

    - #### getPreferredPersist

          public GraphComputer.Persist getPreferredPersist()

      Specified by:
        `getPreferredPersist` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getFeatures

          public VertexProgram.Features getFeatures()

      Specified by:
        `getFeatures` in interface `VertexProgram<org.apache.tinkerpop.gremlin.process.traversal.traverser.util.TraverserSet<Object>>`

    - #### build

          public static TraversalVertexProgram.Builder build()

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.